#define INCL_DOSPROCESS
#include "dualmode.h"

#define maker565( r, g, b ) (unsigned short) (((unsigned short)(b)>>3) | ((unsigned short)(g)&0x00fc)<<3 | ((unsigned short)(r)&0x00f8)<<8)
// Make a 16 bit color value out of R G & B components

struct vidmode_descrip allowed_modes[] = {
  { 640, 480, 8 },
  { 640, 480, 16 },
  { 640, 480, 24 },
  { 640, 480, 32 },
  { 800, 600, 8 },
  { 800, 600, 16 },
  { 800, 600, 24 },
  { 800, 600, 32 },
  { 1024, 768, 8 },
  { 1024, 768, 16 },
  { 1024, 768, 24 },
  { 1024, 768, 32 },
  { 0, 0, 0 }
};

int main( void )
{
  int i, j;
  unsigned char *vidbuf8;
  unsigned short *vidbuf16;

  struct MGLSC_event_handlers eventhandler =
  {
    NULL,
    // Additional window procedure
    NULL,
    // Window initializer
    NULL,
    // Input event handler
    NULL,
    // Window closed event handler
    NULL,
    // PM menu action processing
  };

  MGLSC_init( 640, 480, 16, &eventhandler,
   "Dual-Mode Library Test", "Dual-Mode Library Test", allowed_modes,
   MGLSC_WINDOW_DECOR_TASKLIST | MGLSC_WINDOW_DECOR_MINMAX |
   MGLSC_WINDOW_DECOR_SYSMENU  | MGLSC_WINDOW_DECOR_SYSMENU |
   MGLSC_WINDOW_DECOR_TITLEBAR, 1, 0 );

  vidbuf16 = MGLSC_clientState()->vidbuffer;

  for ( i=0; i<480; ++i )
  {
    for ( j=0; j<640; ++j )
    {
      vidbuf16[ (i*640)+j ] =
       maker565( (i*255) / 480,
                 ((i+j)*255 / (640 + 480)),
                 (j*255) / 640 );
    }
  }

  WinPostMsg( MGLSC_clientState()->clientwin, WM_BLITFRAME, 0, 0 );

  DosSleep( 5000 );

  WinPostMsg( MGLSC_clientState()->clientwin, WM_TOGGLEFS, 0, 0 );

  DosSleep( 5000 );

  MGLSC_reinit( 640, 480, 24, 1, 0 );
  vidbuf8 = MGLSC_clientState()->vidbuffer;

  for ( i=0; i<480; ++i )
  {
    for ( j=0; j<640; ++j )
    {
      vidbuf8[ (((i*640)+j)*3) + 0 ] = ((i*255) / 480);
      vidbuf8[ (((i*640)+j)*3) + 1 ] = ((i+j)*255 / (640 + 480));
      vidbuf8[ (((i*640)+j)*3) + 2 ] = ((j*255) / 640 );
    }
  }

  WinPostMsg( MGLSC_clientState()->clientwin, WM_BLITFRAME, 0, 0 );

  DosSleep( 5000 );

  WinPostMsg( MGLSC_clientState()->clientwin, WM_TOGGLEFS, 0, 0 );

  DosWaitThread( &(MGLSC_clientState()->pm_thread), DCWW_WAIT );
  // Sit and wait for the PM thread to end

  return 0;
}

